"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var registrable_1 = require("./registrable");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
function addScope(scope, target, propertyKey) {
    if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(target) ||
        paradigm_ui_web_shared_1.ObjectExtensions.isNull(target.constructor) ||
        paradigm_ui_web_shared_1.ObjectExtensions.isNull(propertyKey))
        throw new Error("Missing target or propery.");
    var constructor = target.constructor;
    var parameters = constructor[exports.scopeInfoKey];
    if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters))
        parameters = constructor[exports.scopeInfoKey] = {};
    if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.scope))
        parameters.scope = {};
    parameters.scope[propertyKey] = scope;
}
function Directive(parameters) {
    if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters))
        throw new Error("Can not register a directive without an instance of IDirective.");
    return function (constructor) {
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(constructor))
            throw new Error("Missing directive constructor.");
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.name))
            parameters.name = paradigm_ui_web_shared_1.FunctionExtensions.getFunctionName(constructor);
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.factory))
            parameters.factory = constructor["factory"];
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.factory))
            throw new Error("Missing directive factory.");
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.scope) &&
            !paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.scope[exports.scopeInfoKey]))
            parameters.bindings = parameters.scope[exports.scopeInfoKey];
        constructor[registrable_1.registrableMetadataKey] = parameters;
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.module)) {
            parameters.module.registerDirective(constructor);
        }
    };
}
exports.Directive = Directive;
function InputScope(target, propertyKey) {
    addScope("<", target, propertyKey);
}
exports.InputScope = InputScope;
function OutputScope(target, propertyKey) {
    addScope("&", target, propertyKey);
}
exports.OutputScope = OutputScope;
function TextScope(target, propertyKey) {
    addScope("@", target, propertyKey);
}
exports.TextScope = TextScope;
function TwoWayScope(target, propertyKey) {
    addScope("=", target, propertyKey);
}
exports.TwoWayScope = TwoWayScope;
exports.scopeInfoKey = "$scopeInfo";
