"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var base_directive_1 = require("./base.directive");
var directive_1 = require("../decorators/directive");
var FileDragAndDropDirective = /** @class */ (function (_super) {
    tslib_1.__extends(FileDragAndDropDirective, _super);
    function FileDragAndDropDirective() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FileDragAndDropDirective_1 = FileDragAndDropDirective;
    FileDragAndDropDirective.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        instanceElement[0].addEventListener("dragenter", function () { return instanceElement.addClass("file-drag-enter"); }, false);
        instanceElement[0].addEventListener("dragexit", function () { return instanceElement.removeClass("file-drag-enter"); }, false);
        instanceElement[0].addEventListener("dragend", function () { return instanceElement.removeClass("file-drag-enter"); }, false);
        instanceElement[0].addEventListener("dragleave", function () { return instanceElement.removeClass("file-drag-enter"); }, false);
        instanceElement[0].addEventListener("dragover", function (e) {
            instanceElement.addClass("file-drag-enter");
            e.dataTransfer.dropEffect = "copy";
            e.stopPropagation();
            e.preventDefault();
        }, false);
        instanceElement[0].addEventListener("drop", function (e) {
            scope.$eval(instanceAttributes["fileSelected"], { files: e.dataTransfer.files });
            instanceElement.removeClass("file-drag-enter");
            e.stopPropagation();
            e.preventDefault();
        }, false);
    };
    FileDragAndDropDirective.factory = function () {
        return new FileDragAndDropDirective_1();
    };
    FileDragAndDropDirective = FileDragAndDropDirective_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "fileDragAndDrop",
            restrict: "A"
        })
    ], FileDragAndDropDirective);
    return FileDragAndDropDirective;
    var FileDragAndDropDirective_1;
}(base_directive_1.DirectiveBase));
exports.FileDragAndDropDirective = FileDragAndDropDirective;
