"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var directive_1 = require("../decorators/directive");
var base_directive_1 = require("./base.directive");
var key_processor_service_1 = require("../services/key-processor.service");
var OnKeyboardDirective = /** @class */ (function (_super) {
    tslib_1.__extends(OnKeyboardDirective, _super);
    function OnKeyboardDirective(keyProcessor) {
        var _this = _super.call(this) || this;
        _this.keyProcessor = keyProcessor;
        return _this;
    }
    OnKeyboardDirective_1 = OnKeyboardDirective;
    OnKeyboardDirective.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var _this = this;
        var keyActions = this.keyProcessor.parseActions(instanceAttributes["onKeyboard"]);
        if (keyActions.any(function (x) { return x.eventType === "keypress"; }))
            instanceElement.keypress(function (e) { return _this.keyProcessor.evaluateKeyActions(keyActions, "keypress", scope, e); });
        if (keyActions.any(function (x) { return x.eventType === "keydown"; }))
            instanceElement.keydown(function (e) { return _this.keyProcessor.evaluateKeyActions(keyActions, "keydown", scope, e); });
        if (keyActions.any(function (x) { return x.eventType === "keyup"; }))
            instanceElement.keyup(function (e) { return _this.keyProcessor.evaluateKeyActions(keyActions, "keyup", scope, e); });
    };
    OnKeyboardDirective.factory = function (keyProcessor) {
        return new OnKeyboardDirective_1(keyProcessor);
    };
    OnKeyboardDirective = OnKeyboardDirective_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "onKeyboard",
            restrict: "A",
            dependencies: [key_processor_service_1.KeyProcessorService]
        })
    ], OnKeyboardDirective);
    return OnKeyboardDirective;
    var OnKeyboardDirective_1;
}(base_directive_1.DirectiveBase));
exports.OnKeyboardDirective = OnKeyboardDirective;
