"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var directive_1 = require("../decorators/directive");
var base_directive_1 = require("./base.directive");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var TooltipDirective = /** @class */ (function (_super) {
    tslib_1.__extends(TooltipDirective, _super);
    function TooltipDirective() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TooltipDirective_1 = TooltipDirective;
    TooltipDirective.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var options = this.getOptions(instanceAttributes, "tooltipsterOptions");
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(options) || paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.content)) {
            this.normalTooltip(instanceElement, scope, instanceAttributes);
        }
        instanceElement.tooltipster(options);
    };
    TooltipDirective.prototype.normalTooltip = function (control, scope, instanceAttributes) {
        scope.$watch(function () { return instanceAttributes["title"]; }, function (newValue) {
            if (paradigm_ui_web_shared_1.StringExtensions.isNullOrWhiteSpace(newValue))
                return;
            var tooltipsterData = control.data("tooltipster-ns");
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(tooltipsterData)) {
                control.removeAttr("title");
                control.tooltipster("content", newValue);
            }
        });
    };
    TooltipDirective.factory = function () {
        return new TooltipDirective_1();
    };
    TooltipDirective = TooltipDirective_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "tooltip",
            restrict: "A",
            bindings: {
                tooltipOptions: "@",
                tooltipCose: "&",
                tooltipParameter: "="
            }
        })
    ], TooltipDirective);
    return TooltipDirective;
    var TooltipDirective_1;
}(base_directive_1.DirectiveBase));
exports.TooltipDirective = TooltipDirective;
